// Copyright Varjo Technologies Oy. All Rights Reserved.

#pragma once

#include "EyeTrackerTypes.h"
#include "IEyeTracker.h"
#include "VarjoEyeTrackerTypes.h"
#include "VarjoGaze.h"

class FVarjoEyeTracker : public IEyeTracker
{
public:
	FVarjoEyeTracker();
	virtual ~FVarjoEyeTracker();
	virtual void SetEyeTrackedPlayer(APlayerController* PlayerController) override;
	virtual bool GetEyeTrackerGazeData(FEyeTrackerGazeData& OutGazeData) const override;
	virtual bool GetEyeTrackerStereoGazeData(FEyeTrackerStereoGazeData& OutGazeData) const override;
	virtual EEyeTrackerStatus GetEyeTrackerStatus() const override;
	virtual bool IsStereoGazeDataAvailable() const override;

	void Reset();
	void GetGazeRay(FVector & start, FVector & direction, float& focusDistance);
	void GetGazeArray(TArray<FVarjoEyeTrackingData>& gazeData);
	void GetGazeRawArray(TArray<varjo_Gaze>& gazeData);
	void RequestGazeCalibration();
	bool GetVarjoEyeTrackerGazeData(FVarjoEyeTrackingData & OutGazeData) const;
	EVarjoEyeTrackingCalibrationStatus GetCalibrationStatus() const;
	
private:
	friend class FVarjoEyeTrackerModule;
	TSharedPtr<IVarjoVREyeTracker, ESPMode::ThreadSafe> m_VREyeTracker;
};
