// Copyright Varjo Technologies Oy. All Rights Reserved.

using System.IO;

namespace UnrealBuildTool.Rules
{
	public class VarjoEyeTracker : ModuleRules
	{
		public VarjoEyeTracker(ReadOnlyTargetRules Target)
				: base(Target)
		{
            if (Target.bIsEngineInstalled)
                PCHUsage = ModuleRules.PCHUsageMode.NoSharedPCHs;

            PrivateIncludePathModuleNames.AddRange(new string[]
				{
					"TargetPlatform",
					"VarjoHMD"
				});

			PublicDependencyModuleNames.AddRange(
				new string[]
				{
					"EyeTracker",
					"VarjoHMD",
					"RenderCore",
				}
			);

			PrivateDependencyModuleNames.AddRange(
				new string[]
				{
					"Core",
					"CoreUObject",
					"ApplicationCore",
					"Engine",
					"InputCore",
					"HeadMountedDisplay",
					"VarjoHMD",
				}
			);

			AddEngineThirdPartyPrivateStaticDependencies(Target, "OpenVR");
		}
	}
}
